/* read netphone logfiles and generate invoice files */
/* neu in Version 0.82: Datei einlesen mit Zusatzfixkosten */
/* neu in Version 0.93: Universelle Konfigurationsdatei */

#include <stdio.h>
#include <getopt.h>

#define logfilename "/var/log/netphone"
#define cfgfilename "/etc/tkrech.cfg"
#define pfennig 12

#define maxlines 2000
#define yes 1
#define no 0
#define maxeposten 50
#define maxtexlength 50
#define MAXONFIRST 25
#define MAXONFOLLOWING 44
#define anznst 5
/* netphone=5  zweiacht=8 */

struct adr_t {
	char strasse[120], name[120], plz[6], ort[25], closing[255];
} adrs[17];
static char outl[maxlines][100];
static int cn = 0;
static int cg = 0;   /* Anzahl der Anrufe im Abrechnungszeitraum */
static int cgnull = 0;
static int epositions, eposdm;
static int texlength = 0;
static int unitsum, logmon, lognst, betrag, ggeb, twonst;
struct epos_t {
	int dm;
	char name[60];
} eposten[maxeposten];
static char texheader[maxtexlength][255];
static char accname[40], accnumber[20], accbank[30], accblz[20];
static int secondary;


initfields()
{
	int i;
	
	for(i=0;i<maxlines;i++)
		strcpy(outl[i], "");
}


threespacecopy(char *dest, char *source)
{
	int i, d=0, f=0;
	
	for(i=0; i<strlen(source); i++) {
		if((f>=3) && (source[i]!='\n')) dest[d++]=source[i];
		if(source[i]==' ') f++;
	}
	dest[d]='\0';
}


readextrapos(char *efilename)
{
	FILE *eposf;
	char inpline[90], b[60];
	int i, n, m, d;

	if ((eposf = fopen(efilename, "r")) == NULL) {
		fprintf(stderr, "Fehler: Extrapositionen-Datei %s nicht gefunden!\n", efilename);
		exit(2);
	}
	epositions=eposdm=0;
	while(fgets(inpline, 90, eposf) != NULL) {
		if(inpline[0] != '#') {
			sscanf(inpline, "%d %d %i", &n, &m, &d);
			if (((lognst==n)||(twonst==n)) && ((m==logmon)||(m==0))) {
				++epositions;
				threespacecopy(eposten[epositions].name, inpline);
				eposdm+=(eposten[epositions].dm = d);
			}
		}
	}
	fclose(eposf);
}


unsigned int getdmdata(unsigned int lnst, unsigned int ltwo, unsigned int lmon)
{
	FILE *nplogf;
	char inpline[90], datestr[15], dauer[9], nummer[40], betrag[6], einh[3];
	char *special;
	unsigned int app, unitsum = 0, nextonebills = 0, matchedspecial = 0;
	
	nplogf = fopen(logfilename, "r");
	sprintf(outl[cn++], "Rufnummer & Nst & Datum/Uhrzeit & Einh & Betrag & Dauer\\\\ \\hline\n");
	cgnull = cn;
	while((fgets(inpline, 90, nplogf))!=NULL)
		if(!strncmp(inpline, "App ", 4)) {
			sscanf(inpline, "App %d an %s vom %s %s %s DM %s\n",
			 &app, nummer, datestr, einh, betrag, dauer);
			if (((app == lnst) || (app == ltwo) || (lnst == 0)) && (((datestr[3]-48)*10+datestr[4]-48) == lmon)) {
			   if((secondary==0) || nextonebills) {
				if (unitsum > 0) strcat(outl[cn-1], "\n");
				sprintf(outl[cn++], "%s & %d & %s & %s & %s DM & %s\\\\", nummer, app, datestr, einh, betrag, dauer);
				cg++;
				unitsum+=atoi(einh);
				nextonebills = 0;
			   }
			}
		}
		else {
		    if(secondary!=0) {     /* Testen nach Zweitapparat an selber Nebenstelle */
		        inpline[strlen(inpline)-1] = '\0'; /* CR wegmachen */
			for(special=inpline+strlen(inpline)-1; special[0]!=' '; special--);
			if(!strcmp(special, " #BUSY@256@#"))
				matchedspecial = 6;
			else
				if(matchedspecial>0) matchedspecial--;
			if(!strncmp(special, " #CONNECT", 9) && (special[10]-'0'==lnst) && (matchedspecial>0))
				nextonebills = 1;
		    }
		}
	fclose(nplogf);
	sprintf(outl[cn++], " \\hline\n");
	return(unitsum);
}


pz(char outz[], int betrag)
{
	if(betrag<0) {
	  sprintf(outz, "%3d,%2d", betrag/100, -betrag%100);
	  if (-betrag%100 < 10) outz[4] = '0';
	} else {
	  sprintf(outz, "%3d,%2d", betrag/100, betrag%100);
	  if (betrag%100 < 10) outz[4] = '0';
	}
}


prtabbrk()
{
	printf("\\hline \\end{tabular}\\end{center}\n\\newpage\n\n");
	printf("\\begin{center}\n\\begin{tabular}{lcccrr} \\hline\n");
	printf("Rufnummer & Nst & Datum/Uhrzeit & Einh & Betrag & Dauer\\\\ \\hline\n");
}


outthem()
{
	int i, j;
	int newp_nine;
	
	newp_nine = (cg>MAXONFIRST-1)? no : (cg>9);   /* wird gesetzt, wenn Anzahl der Anrufe zwischen 10 und 24 */
	for(i=0, j=0; i<cn; i++) {
		if (i>=cgnull) j++;   /* && (j<cg) */
		if (newp_nine && (i == cgnull+cg+2))
			printf("\\newpage\n\n");
		if (j == MAXONFIRST)
		  if (i<cn) prtabbrk();
		if ((j>MAXONFIRST) && ((j-MAXONFIRST)%MAXONFOLLOWING == 0))
		  if (i<cn) prtabbrk();
		printf("%s", outl[i]);
	}
}


lcase(char s[])
{
	int i;

	for(i=0; i<strlen(s); i++)
		s[i] = tolower(s[i]);
}


int readcfgfile()
{
	FILE *cfgf;
	char cfgin[255], cfgcmd[128], *cfgarg;
	int idx;
	
	if ((cfgf=fopen(cfgfilename, "r"))!=NULL) {
	    while((fgets(cfgin, 254, cfgf))!=NULL) {
	        sscanf(cfgin, "%s\n", cfgcmd);
	        for(cfgarg=cfgcmd; cfgarg[0]!=' '; cfgarg++);
	        cfgarg++;
	        cfgarg[strlen(cfgarg)-1]='\0'; /* CR wegmachen */
	        lcase(cfgcmd);
	        if(isdigit(cfgcmd[1])) {
	            idx = cfgcmd[1] - '0';
	            if((idx<1) || (idx>anznst)) {
	                fprintf(stderr, "Ungltige Nebenstelle in cfg: '%s'\n", cfgcmd);
	                exit(1);
	            }
	            cfgcmd[1]='N';
	        }
	        if(!strcmp(cfgcmd, "aNname")) strcpy(adrs[idx].name, cfgarg);
	        if(!strcmp(cfgcmd, "aNstreet")) strcpy(adrs[idx].strasse, cfgarg);
	        if(!strcmp(cfgcmd, "aNplz")) strcpy(adrs[idx].plz, cfgarg);
	        if(!strcmp(cfgcmd, "aNcity")) strcpy(adrs[idx].ort, cfgarg);
	        if(!strcmp(cfgcmd, "aNclosing")) strcpy(adrs[idx].closing, cfgarg);
	        if(!strcmp(cfgcmd, "bNname")) strcpy(adrs[idx+8].name, cfgarg);
	        if(!strcmp(cfgcmd, "bNstreet")) strcpy(adrs[idx+8].strasse, cfgarg);
	        if(!strcmp(cfgcmd, "bNplz")) strcpy(adrs[idx+8].plz, cfgarg);
	        if(!strcmp(cfgcmd, "bNcity")) strcpy(adrs[idx+8].ort, cfgarg);
	        if(!strcmp(cfgcmd, "bNclosing")) strcpy(adrs[idx+8].closing, cfgarg);
	        if(!strcmp(cfgcmd, "accountname")) strcpy(accname, cfgarg);
	        if(!strcmp(cfgcmd, "accountnumber")) strcpy(accnumber, cfgarg);
	        if(!strcmp(cfgcmd, "accountbank")) strcpy(accbank, cfgarg);
	        if(!strcmp(cfgcmd, "accountblz")) strcpy(accblz, cfgarg);
	        if(!strcmp(cfgcmd, "texheader"))
	            while((fgets(cfgin, 254, cfgf))!=NULL) {
	                cfgin[strlen(cfgin)-1]='\0'; /* CR wegmachen */
	                strcpy(texheader[texlength++], cfgin);
	            }
	    }
	    fclose(cfgf);
	}
	else {
	    fprintf(stderr, "tkrech konnte die Datei %s nicht ffnen!\n", cfgfilename);
	    exit(1);
	}
}


void main(int argc, char **argv)
{
	char asdf[6], zweitb[30];
	int i, optc, firstarg;
	
	secondary = 0;
	while((optc = getopt(argc, argv, "s")) != EOF) switch(optc) {
		case 's' : secondary = 8; break;
	}
	
	if ((argc < 3) || (argc > (4+(secondary==8)))) {
		printf("\nUsage: tkrech [-s] Nebenstellennummer Monatszahl [Extraposten-Datei]\n\n");
		exit(1);
	}
	firstarg = 1+(secondary==8);
	logmon = atoi(argv[firstarg+1]);
	lognst = atoi(argv[firstarg]);
	if (lognst > 5) {
		twonst = lognst%10;
		lognst/=10;
	}
	else
		twonst = 0;
	
	if(twonst && (secondary!=0)) {
		printf("\nBei Wahl des Zweitbenutzers kann nur eine Nebenstelle abgerechnet werden!\n\n");
		exit(1);
	}
	initfields();
	if (argc == 4+(secondary==8)) {
		readextrapos(argv[firstarg+2]);
	}
	else
		epositions = 0;

	readcfgfile();
	if(texlength == 0) {
		fprintf(stderr, "Im cfg-file ist kein texheader definiert!\n");
		exit(1);
	}
	
	for(i=0; i<texlength; i++)
		sprintf(outl[cn++], "%s\n", texheader[i]);
	
	sprintf(outl[cn++], "%s\\\\\n%s\\\\\n\\medskip\n{\\bf %s} %s\n\\bigskip}\n", adrs[lognst+secondary].name, adrs[lognst+secondary].strasse, adrs[lognst+secondary].plz, adrs[lognst+secondary].ort);
	if(secondary)
		strcpy(zweitb, ", Zweitbenutzer");
	else
		strcpy(zweitb, "");
	if (twonst == 0)
		sprintf(outl[cn++], "\\opening{{\\em Monatsrechnung Nebenstelle %d%s}}\n\n", lognst, zweitb);
	else
		sprintf(outl[cn++], "\\opening{{\\em Monatsrechnung Nebenstellen %d und %d}}\n\n", lognst, twonst);
	sprintf(outl[cn++], "\\begin{center}\n\\begin{tabular}{lccccr} \\hline\n");

	unitsum = getdmdata(lognst, twonst, logmon);

	sprintf(outl[cn++], "\n\\end{tabular}\\end{center}\n\n");
	betrag = unitsum*pfennig;
	if(!secondary)
		ggeb = 2700;
	else
		ggeb = 0;
	pz(asdf, betrag);
	sprintf(outl[cn++], "\\begin{center}\n\\begin{tabular}{lrr} \\hline\n");
	sprintf(outl[cn++], "Gesamtbetrag Gespr\"ache Monat %d: & DM & %s \\\\\n", logmon, asdf);
	pz(asdf, ggeb);
	sprintf(outl[cn++], "Anteilige Monatsgrundgeb\"uhr & DM & %s\\\\\n", asdf);
	if (epositions > 0) {
		for (i=1; i<=epositions; i++) {
			pz(asdf, eposten[i].dm);
			sprintf(outl[cn++], "%s & DM & %s\\\\\n", eposten[i].name, asdf);
		}
		pz(asdf, betrag+ggeb+eposdm);
	}
	else
		pz(asdf, betrag+ggeb);
	sprintf(outl[cn++], "\\hline {\\bf Summe} & {\\bf DM} & {\\bf %s}\\\\ \\hline \\hline\n", asdf);
	sprintf(outl[cn++], "\\end{tabular}\\end{center}\n\\vspace{6mm}\n");
	sprintf(outl[cn++], "{\\small Zu \"uberweisen an %s, Konto %s bei der\n", accname, accnumber);
	sprintf(outl[cn++], "%s, BLZ %s}\n\n", accbank, accblz);
	sprintf(outl[cn++], "\\closing{%s}\n", adrs[lognst].closing);
	sprintf(outl[cn++], "\\end{letter}\n\\end{document}\n");
	outthem();
}
